
Error handling API

This API allows you to gather the information contained in the
LoadLeveler error object and output that information as an error
message.



ll_error subroutine

Purpose

ll_error - Converts a LoadLeveler error object to an error message
string. As an option, you can print the error message string to stdout
or stderr.

Library

LoadLeveler API library libllapi.a (AIX) or libllapi.so (Linux)

Syntax
 
#include "llapi.h"

char *ll_error (LL_element **errObj, int print_to);

Parameters

errObj
   This is the address of a pointer to a LoadLeveler error object. A
   NULL errObj pointer indicates that any internal error objects will be
   printed.

print_to    
   *  1 - print error message to stdout
   *  2 - print error message to stderr
   *  Any other value - no error message printed

Description

This subroutine also prints any error messages generated by APIs that do
not support an error object as a parameter. When called with a NULL
errObj, any error messages previously stored by such APIs, will be
printed as directed by the print_to parameter and then deleted.

It is the caller's responsibility to free the storage associated with
the error message string.

The LoadLeveler error object pointed to by *errObj is deleted upon exit
and NULL is assigned to *errObj.

Return Values

The ll_error API returns a NULL return code if there is no error object
to print.
