
llclusterauth - Generates public and private keys

Purpose

llclusterauth - Generates public and private keys that are used to
provide secure intercluster communications.  

Syntax

llclusterauth [-?] | [-H] | [-v] | [-k]

Flags
 
-?       Provides a short usage message.

-H       Provides extended help information.

-v       Displays the name of the command, release number, service
         level, service level date, and lowest level of the operating
         system to run this release.

-k       Creates a public key, a private key, a security certificate,
         and a directory for authorized keys. The keys and certificate
         are created in the /var/LoadL/ssl directory for AIX and in the
         /var/opt/LoadL/ssl directory for Linux. 
         *  The private key is stored in id_rsa
         *  The public key is stored in id_rsa.pub
         *  The security certificate is stored in id_rsa.cert
         *  The authorized keys are stored in authorized_keys
          
         This command must run with root authority when using the -k
         flag to create key files.

If any directory in the path for the security files does not exist, the
command will create the directory and set the owner to root and set the
permissions to '0700'. The key and certificate files will be owned by
root with permissions of '0600'.

Description

The llclusterauth command generates public and private keys that are
used to provide secure intercluster communications. When multicluster
security is configured to use Secure Sockets Layer (SSL), a connection
on a secure port will be accepted only if the public key for the node
requesting the connection is stored in a file in the authorized keys
directory on the node being connected to.

Standard Error

An error message is issued and the command exits for the following error
cases:

*  The command process does not have root authority
*  A required directory for the security files cannot be created
*  A security file cannot be created

Security

LoadLeveler administrators can issue this command.
