
lldbconvert - Job migration utility

Purpose

lldbconvert - Administrators can use the lldbconvert utility to convert
jobs from LoadLeveler 3.3 format to LoadLeveler 3.4 format.  

Syntax

lldbconvert [-d] [-D] [-H] [-?] [-v] [-o OpSys]

Flags

-d       Displays contents of input spool (no conversion).

-D       Converts LoadLeveler 3.3 spool to LoadLeveler 3.4 spool and
         displays contents of output spool after conversion.

-H       Provides extended help information.

-?       Provides a short usage message.

-v       Displays the name of the command, release number, service
         level, service level date, and lowest level of the operating
         system to run this release.

-o OpSys Converts LoadLeveler 3.3 spool to LoadLeveler 3.4 spool,
         forcing OpSys test to: 'OpSys == "OpSys"' if it occurs in
         Requirements or Preferences.

Description

On machines where jobs need to be migrated, log in as loadl (or the
primary LoadLeveler user ID defined in /etc/LoadL.cfg) and run
lldbconvert from the local LoadLeveler spool directory.

The -o flag is needed when the operating system specified in the
requirement statement no longer matches the operating system after the
migration, for example, if it changes from AIX52 to AIX53. This flag
converts requirements statements in the form OpSys=="your_os".
Statements in other formats (such as those with your_os not enclosed in
double quotes) are not converted.

When you create the LoadL_admin file for the version to which you are
migrating, you should preserve all of the job class definitions used in
the version from which you are migrating. For example, if a converted
job needs to run as a large class job, and class large is not defined in
the LoadLeveler 3.4 LoadL_admin file, the job will never be run.

lldbconvert only converts job steps that are in one of the following
states: Idle, Hold, Deferred, or NotQueued. If the conversion is
successful, you will receive further instructions from lldbconvert on
what to do before starting LoadLeveler on the given machine.

Once you run lldbconvert, do not move the converted job queues to
another Schedd machine.

Security

LoadLeveler administrators can issue this command.
