
llprio - Change the user priority of submitted job steps

Purpose

llprio - Changes the user priority of one or more job steps in the
LoadLeveler queues. You can adjust the priority by supplying a + (plus)
or - (minus) immediately followed by an integer value. llprio does not
affect a job step that is running, even if its priority is lower than
other jobs steps, unless the job step goes into the Idle state.

Syntax

llprio [-?] [-H] [-v] [-q] [-X cluster_name] [+integer | -integer | 
       -p priority] joblist

Flags

-? 
   Provides a short usage message.

-H 
   Provides extended help information.

-v 
   Displays the name of the command, release number, service level,
   service level date, and lowest level of the operating system to run
   this release.

-q 
   Specifies quiet mode: print no messages other than error messages.

-X cluster_name
   Specifies the name of a single cluster where the command is to run.

+ | - integer
   Operates on the current priority of the job step, making it higher
   (closer to execution) or lower (further from execution) by adding or
   subtracting the value of integer.

-p priority
   Is the new absolute value for priority. The valid range is 0-100
   (inclusive) where 0 is the lowest possible priority and 100 is
   highest.

joblist
   Is a blank-delimited list of jobs. When a job identifier is
   specified, the command action is taken for all steps of the job. At
   least one job or step identifier must be specified. 

   The format of a job identifier is host.jobid. The format of a step
   identifier is host.jobid.stepid.
  
   where:
    
   *  host is the name of the machine that assigned the job and step
      identifiers.
   *  jobid is the job number assigned to the job when it was submitted.
   *  stepid is the job step number assigned to the job step when it was
      submitted.
    
   The job or step identifier may be specified in an abbreviated form,
   jobid or jobid.stepid, when the command is invoked on the same
   machine that assigned the job and step identifiers. In this case,
   LoadLeveler will use the local machine's hostname to construct the
   full job or step identifier.

Description

The user priority of a job step ranges from 0 to 100 inclusively, with
higher numbers corresponding to greater priority. The default priority
is 50. Only the owner of a job step or the LoadLeveler administrator can
change the priority of that job step. Note that the priority is not the
UNIX nice priority.

Priority changes resulting in a value less than 0 become 0.

Priority changes resulting in a value greater than 100 become 100.

Any change to a job step's priority applied by a user is relative only
to that user's other job steps in the same class. If you have three job
steps enqueued, you can reorder those three job steps with llprio but
the result does not affect job steps submitted by other users,
regardless of their priority and position in the queue.

For more information, see the "Setting and changing the priority of a
job" topic in TWS LoadLeveler: Using and Administering.

Examples

1. This example raises the priority of job 4, job step 1 submitted to
   machine bronze by a value of 25: 

   llprio +25 bronze.4.1

2. This example sets the priority of job 18, job step 4 submitted to
   machine silver to 100, the highest possible value: 

   llprio -p 100 silver.18.4
   
   You should receive a response similar to the following:
    
   llprio: Priority command has been sent to the central manager.

Security

LoadLeveler administrators and users can issue this command.