
llrmres - Cancel a reservation

Purpose

llrmres - Cancels a reservation in LoadLeveler.

Syntax
 
llrmres  { -? | -H | -v | [ -q] { [-u user_list] [-g group_list]
         [-h all | -h host_list] [-B all | -B base_partition_list] |
         [-R all | -R reservation_list] } }

Flags
 
-?       Provides a short usage message.

-H       Provides extended help information.

-v       Displays the name of the command, release number, service
         level, service level date, and lowest level of the operating
         system to run this release.

-q       Specifies quiet mode: print no messages other than error
         messages.

-u user_list
         Specifies a blank-delimited list of user IDs. Reservations to
         be canceled are owned by one of these users.

-g group_list
         Specifies a blank-delimited list of LoadLeveler groups.
         Reservations to be canceled are owned by one of these groups.

-h all  
-h host_list
         Specifies a blank-delimited list of machines or all machines.
         Reservations to be canceled use one or more of these machines.

-B all    
-B base_partition_list
         Specifies a blank-delimited list of Blue Gene base partitions
         or all Blue Gene base partitions. Reservations to be canceled
         use one or more of these Blue Gene base partitions.

-R all    
-R reservation_list
         Is a blank-delimited list of reservation identifiers to be
         canceled. A LoadLeveler administrator can specify the reserved
         word all to cancel all reservations in the system.
         Nonadministrators can specify the reserved word all to cancel
         all of the reservations that they own. The format of a full
         LoadLeveler reservation identifier is [host.]rid[.r]. 

         where:
          
         *  host is the name of the machine that assigned the
            reservation identifier.
         *  rid is the number assigned to the reservation when it was
            created. An rid is required.
         *  r indicates that this is a reservation ID (r is optional).
          
         The reservation identifier may be specified in an abbreviated
         form, rid[.r], when the command is invoked on the same machine
         that assigned the reservation identifier. In this case,
         LoadLeveler will use the local machine's host name to construct
         the full reservation identifier.

Description

The llrmres command is for LoadLeveler administrators and owners of a
reservation. Owners of reservations can cancel their own reservations. A
LoadLeveler administrator can cancel any reservation. The state of a job
step will not be changed directly by the cancellation of a reservation.
Reservations satisfying all criteria specified by the -u, -g, -h, or -B
flags will be canceled if more than one of these options are present.
The -h and -B flags are mutually exclusive. The llqres command can be
used to see the status of the reservation.

This command is for the BACKFILL scheduler only.

Examples

1. To request to cancel all reservations owned by user ID iris that use
   machine c188f2n01, issue the following command. Note that this
   request can be made either by an administrator or the user iris. 

   llrmres -u iris -h c188f2n01

   You should receive a response similar to the following: 
   The request to remove reservations has been sent to the central 
   manager.

2. To request that the LoadLeveler administrator cancel all
   reservations, issue: 

   llrmres -R all

   You should receive a response similar to the following: 
   The request to remove reservations has been sent to the central 
   manager.

3. To request that the LoadLeveler administrator cancel all reservations
   of Blue Gene resources, issue: 

   llrmres -B all

   You should receive a response similar to the following: 
   The request to remove reservations has been sent to the central 
   manager.

4. To request that the LoadLeveler administrator cancel all reservations
   on nodes that are not Blue Gene compute nodes (C-nodes), issue: 

   llrmres -h all

   You should receive a response similar to the following: 
   The request to remove reservations has been sent to the central 
   manager.

Security

LoadLeveler administrators and users can issue this command.
