#include <stdio.h>
#include <math.h>
#if defined(__SUSE_LINUX_9_X86_64__) || defined(__RHEL_LINUX_3_X86_64__) || defined(__SUSE_LINUX_10_X86_64__)
#include <time.h>
#else
#include <sys/time.h>
#endif

/* 
 * these three variables control how long this thing runs.  The number
 * of iterations is
 *
 *       COUNTER * LOTS
 * As distributed LOTS is set to 1024 * 1024 or a "mega".
 *                COUNTER is set to 15.
 * 
 * These 15 megaloops eat about 60 seconds of CPU time on my own
 * model 520 machine.
 * 
 * To compile this program: cc  -o job3 job3.c -lm
 *                      or: gcc -o job3 job3.c -lm
 *                      
 * On SLES9 Opteron platforms (x86_64), use the following to compile:
 *     gcc -O -D__SUSE_LINUX_9_X86_64__ -o job3 job3.c -lm
 *
 * On SLES10 Opteron platforms (x86_64), use the following to compile:
 *     gcc -O -D__SUSE_LINUX_10_X86_64__ -o job3 job3.c -lm
 *
 * On RHEL3 Opteron platforms (x86_64), use the following to compile:
 *     gcc -O -D__RHEL_LINUX_3_X86_64__ -o job3 job3.c -lm
 *
 */
 
#define COUNTER 15
#define LOTS 1024 * 1024
#define LOTSNLOTS  COUNTER * LOTS

/*
 * this does a bunch of pointless computation.  you can control how much it
 * does by varying the three defines above
 */
main()
{
	int		i, j, k;
	double	a, x, y, z; 
	time_t	current_time;

	x = 100.0;
	y = 200.0;
	z = 300.0;
	j = 20;
	k = 40;

	for ( i = 0; i < LOTSNLOTS; i++) {
  	  	x = sqrt(y);   
		y = x * x;
		z += x;
		j += k;
		k -= 1;
		
		a = x / y + 200 * 40.22;
		if ((i % 500000) == 0) {

			time(&current_time);
			printf("Next 1000. Current count: %d at %s\n", i,
				asctime(localtime(&current_time)));
			fflush(stdout);
		} /* end if ((i */
	} /* end i */
  exit(0);
} /* end main */

