#!/bin/sh
#
# This demonstrates simple submission of a c program.  To compile the
# program:
#      cc  -O -o job3 job3.c -lm
# or:
#      gcc -O -o job3 job3.c -lm
#
# On SLES9 Opteron platforms (x86_64), use the following to compile:
#      gcc -O -D__SUSE_LINUX_9_X86_64__ -o job3 job3.c -lm
#
# On SLES10 Opteron platforms (x86_64), use the following to compile:
#      gcc -O -D__SUSE_LINUX_10_X86_64__ -o job3 job3.c -lm
#
# On RHEL3 Opteron platforms (x86_64), use the following to compile:
#      gcc -O -D__RHEL_LINUX_3_X86_64__ -o job3 job3.c -lm
#
#
# Then
#   llsubmit job3.cmd
#
# This program consumes cycles and generates output.  You can control 
# the length of time it runs by modifying the c source.  Instructions 
# for doing this are in job3.c
#
# when complete output will be in the file
#   job3.out.xxx
# where xxx is the clusterid assigned when the jobs submitted.
#
# @ executable = job3
# @ output = job3.out.$(Cluster)
# @ error = job3.err.$(Cluster)
# @ queue

