/*
 *  This sample program demostrates the use of the ll_cluster_auth
 *  API. The program takes no arguments.  The ll_cluster_auth API is
 *  invoked to generate a private key, a public key, a certificate,
 *  and the authorized keys directory. If the API is successful, the 
 *  program returns 0, otherwise an error message is printed to stderr
 *  and 1 is returned.
 */

#include<stdio.h>
#include<stdlib.h>
#include "llapi.h"

main(int argc, char *argv[])
{
	LL_element *errObj = NULL;
	LL_cluster_auth_param auth_param;
	LL_cluster_auth_param *param_list[2];
	int rc;

	/* Set type to generate keys */
	auth_param.type = CLUSTER_AUTH_GENKEY;

	param_list[0] = &auth_param;
	param_list[1] = NULL;

	rc = ll_cluster_auth(LL_API_VERSION, &errObj, param_list);

	if (rc != 0) {
		/* Function failed, print error message to stderr */
		ll_error(&errObj,2);
		rc = 1;
	}
	exit(rc);
}
