#include<stdio.h>
#include<stdlib.h>
#include "llapi.h"

main(int argc,char *argv[]) {
	LL_element *queryObject=NULL, *mcluster=NULL;
	int i, rc, num, err;
	char * received_temp_string = NULL;
	int received_temp_int = 0;

	/* Initialize the query for jobs */
	queryObject = ll_query(MCLUSTERS);

	rc = ll_set_request(queryObject,QUERY_ALL,NULL,ALL_DATA);

	/* Request the objects from the Schedd daemon */
	mcluster = ll_get_objs(queryObject, LL_SCHEDD, NULL, &num, &err);

	/* Did we get a list of objects ? */
	if (mcluster == NULL) {
		printf("  ll_get_objs returned a NULL object.\n");
		printf("  err = %d\n",err);
	} else {
		/* Loop through the list and process */
		printf(" RESULT: number of mclusters in list = %d\n",num);
		while(mcluster) {
			if (ll_get_data(mcluster, LL_MClusterName, &(received_temp_string))==0) {
				if (received_temp_string) {
					printf("%s: type = cluster\n",received_temp_string);
					free(received_temp_string);
					received_temp_string=NULL;
				}
			}
			if (ll_get_data(mcluster, LL_MClusterLocal, &(received_temp_int))==0) { 
				printf("\tLocal = %s\n",(received_temp_int?"True":"False"));
			}
			if (ll_get_data(mcluster, LL_MClusterInboundScheddPort, &(received_temp_int))==0) {
				printf("\tinbound_schedd_port = %d\n",received_temp_int);
			}
			if (ll_get_data(mcluster, LL_MClusterInboundHosts, &(received_temp_string))==0) {
				if (received_temp_string) {
					printf("\tinbound_hosts = %s\n",received_temp_string);
					free(received_temp_string);
					received_temp_string=NULL;
				}
			}
			if (ll_get_data(mcluster, LL_MClusterOutboundHosts, &(received_temp_string))==0) {
				if (received_temp_string) {
					printf("\toutbound_hosts = %s\n",received_temp_string);
					free(received_temp_string);
					received_temp_string=NULL;
				}
			}
			if (ll_get_data(mcluster, LL_MClusterIncludeUsers, &(received_temp_string))==0) {
				if (received_temp_string) {
					printf("\tinclude_users = %s\n",received_temp_string);
					free(received_temp_string);
					received_temp_string=NULL;
				}
			}
			if (ll_get_data(mcluster, LL_MClusterExcludeUsers, &(received_temp_string))==0) {
				if (received_temp_string) {
					printf("\texclude_users = %s\n",received_temp_string);
					free(received_temp_string);
					received_temp_string=NULL;
				}
			}
			if (ll_get_data(mcluster, LL_MClusterIncludeGroups, &(received_temp_string))==0) {
				if (received_temp_string) {
					printf("\tinclude_groups = %s\n",received_temp_string);
					free(received_temp_string);
					received_temp_string=NULL;
				}
			}
			if (ll_get_data(mcluster, LL_MClusterExcludeGroups, &(received_temp_string))==0) {
				if (received_temp_string) {
					printf("\texclude_groups = %s\n",received_temp_string);
					free(received_temp_string);
					received_temp_string=NULL;
				}
			}
			if (ll_get_data(mcluster, LL_MClusterIncludeClasses, &(received_temp_string))==0) {
				if (received_temp_string) {
					printf("\tinclude_classes = %s\n",received_temp_string);
					free(received_temp_string);
					received_temp_string=NULL;
				}
			}
			if (ll_get_data(mcluster, LL_MClusterExcludeClasses, &(received_temp_string))==0) {
				if (received_temp_string) {
					printf("\texclude_classes = %s\n",received_temp_string);
					free(received_temp_string);
					received_temp_string=NULL;
				}
			}

			mcluster = ll_next_obj(queryObject);
			printf("\n");
		}
	}

	/* free objects obtained from Negotiator */
	rc = ll_free_objs(queryObject);

	/* free query element */
	rc = ll_deallocate(queryObject);

}
