#! /bin/ksh
#
# This script compiles 2 programs:
#
#   1. ll_get_machine_list: This program queries LoadLeveler for information
#      about the machines that LoadLeveler has selected to run the tasks of a
#      job step.
#
#   2. ivp: A simple MPI application.
#

# Export MODEFLAGS & WORDSIZE for 64-bit POWER systems running Linux.
#export MODEFLAGS=-m64
#export WORDSIZE=64

# We assume that LoadLeveler has been installed at: /opt/ibmll/LoadL/full
# On AIX, LoadLeveler would be installed at: /usr/lpp/LoadL/full
BASEDIR=/opt/ibmll/LoadL/full
CC=g++

${CC} ${MODEFLAGS} -o ll_get_machine_list -I${BASEDIR}/include -L/usr/lib64 -L/usr/lib -lllapi ll_get_machine_list.c

# We assume that MPICH 1.2.6..13 has been installed at: /opt/osshpc/mpich-1.2.6..13/
# and that llspawn is used to start remote tasks.

export MPICH_DIR=/opt/osshpc/mpich-1.2.6..13
$MPICH_DIR/$WORDSIZE/rsh/bin/mpicc -o ivp -I$MPICH_DIR/$WORDSIZE/rsh/include ivp.c
