#! /bin/ksh
#
# This script compiles 2 programs:
#
#   1. ll_get_machine_list: This program queries LoadLeveler for information
#      about the machines that LoadLeveler has selected to run the tasks of a
#      job step.
#
#   2. ivp: A simple MPI application.
#

# Export MODEFLAGS if building for 64-bit POWER systems running Linux
#export MODEFLAGS=-m64

# We assume that LoadLeveler has been installed at: /opt/ibmll/LoadL/full
# On AIX, LoadLeveler would be installed at: /usr/lpp/LoadL/full
BASEDIR=/opt/ibmll/LoadL/full
CC=g++

# The path /usr/lib64 is only used for 64-bit systems
${CC} ${MODEFLAGS} -o ll_get_machine_list -I${BASEDIR}/include -L/usr/lib64 -L/usr/lib -lllapi ll_get_machine_list.c

# We assume that MVAPICH 0.9.7 has been installed at: /opt/mvapich-0.9.7/
export MPICH_DIR=/opt/mvapich-0.9.7

$MPICH_DIR/bin/mpicc -o ivp -I$MPICH_DIR/include ivp.c

